#include <stdio.h>
#include <fat32.h>
#include <gpio.h>
#include <uart.h>
#include <stm32f4xx.h>
#include <bsp.h>
#include <core.h>
#include <VS10XX.h>
#include <bsp.h>
#include <spi.h>
#include <sdcard.h>
#include <sdcard-spi.h>
#include <fat32.h>
#include <ucdirent.h>
#include <string.h>


extern streamdevice* __opnfiles__[];

void randBoxesDemo()
{
    int16_t x,y,w,h,t,r;
    x=rand()%240;
    y=rand()%320;
    w=rand()%(240-x);
    if(x>y)
        r=(rand()%(y))%(320-y);
    else
        r=(rand()%(x))%(240-x);
    h=rand()%(320-y);
    t=rand()%(10);
    ili9328paintFilRect(&lcd0,x,y,w,h,rand(),t,rand());
    //ili9328paintFilCirc(&lcd0,x,y,r,rand(),t,rand());
    //delay_100us(10);
    //for(volatile int i=0;i<(1024*2);i++);
}

int main()
{
    while(!bspsdcardpresent());
    delay_100us(5000);
    printf("About to initialize SDCARD");
    sdcardDev sdcard2;
    blkdevice sdcard2blkdev;
    dikpartition sdcard2Part1;
    FAT32fs partoche;
    sdcardspimake(&sdcard2,(UHANDLE)SDCARD2SPI,spigetnc,spiputnc,spisetspeed,spigetspeed);
    sdcardspimakeblkdev(&sdcard2blkdev,&sdcard2,bspsdcardselect,bsppowersdcard,bspsdcardpresent,bspsdcardwriteprotected);
    sdcard2blkdev.initialize(&sdcard2blkdev);
    mbropen(&sdcard2blkdev,&sdcard2Part1,1);
    if(FATnoErr==fat32open(&partoche,&sdcard2Part1))
    {
        printf("FAT32 partition opened\n");
        char test[]="                                              \n";
        ucdirent root,folder;
        fat32mkdirent(&partoche,&root);
        fat32getrootfirstent(&root);
        fat32getVolName(&partoche,test);
        printf("Vol Name=%s\n",test);
        fat32getdirentname(&root,test);
        printf("%s\n",test);
        while (DIRENT_EndOfDir!=fat32nextdirent(&root))
        {
            if(test[0]=='m')
            {
                printf("enter music folder\n");
                fat32enterdirent(&root,&folder);
                while (DIRENT_EndOfDir!=fat32nextdirent(&folder))
                {
                    printf("%s\n",test);
                }
            }
            fat32getdirentname(&root,test);
            printf("%s\n",test);
        }
        if(test[0]=='m')
        {
            printf("enter music folder\n");
            fat32enterdirent(&root,&folder);
            while (DIRENT_EndOfDir!=fat32nextdirent(&folder))
            {
                printf("%s\n",test);
            }
        }
    }
    while(1)
    {
        //        printf("Audio Codec reg0=0x%x\n",vs10XXcmdread(&audioCodec0,0));
        // printf("hello ");
        // bsp_lcd0_write_reg(1,0x1234);
        // delay_100us(10000);
        //             randBoxesDemo();

        gpioset(LED1);
        delay_100us(10000);
        gpioclr(LED1);
        delay_100us(10000);

    }
    printf("hello world\n\r");
    return 0;
}






